;JTilePile install script (C) 2008 by V.Termanis

;--------------------------------
;Include Modern UI

  !include "MUI.nsh"

;--------------------------------
;General

  !define VERSION "1.0"

  Name "Tile Pile"
  OutFile "TilePile${VERSION}-Setup.exe"

  ;Default installation folder
  InstallDir "$PROGRAMFILES\TilePile"
  
  ;Get installation folder from registry if available
  InstallDirRegKey HKCU "Software\JTilePile" ""

  ;Vista redirects $SMPROGRAMS to all users without this
  RequestExecutionLevel admin

;--------------------------------
;Version Information

  VIProductVersion "1.0.0.0"
  VIAddVersionKey "ProductName" "Tile Pile"
  VIAddVersionKey "Comments" "Java implementation of the game $\"Tile Pile$\""
  VIAddVersionKey "LegalCopyright" " 2008 J.Mitchell and V.Termanis. All rights reserved."
  VIAddVersionKey "FileDescription" "JTilePile"
  VIAddVersionKey "FileVersion" "1.0.0.0"

;--------------------------------
;Variables

  Var MUI_TEMP
  Var STARTMENU_FOLDER
  Var PROGRAM_LOCATION

;--------------------------------
;Interface Configuration

  !define MUI_ICON "JTP.ico"

  !define MUI_HEADERIMAGE
  !define MUI_HEADERIMAGE_BITMAP "installer_header.bmp"


  !define MUI_WELCOMEFINISHPAGE_BITMAP "installer_welcome.bmp"
  !define MUI_ABORTWARNING
  !define MUI_ABORTWARNING_TEXT "Are you sure you want to leave Tile Pile setup?"
  !define MUI_ABORTWARNING_CANCEL_DEFAULT

;--------------------------------
;Page settings

  !define MUI_WELCOMEPAGE_TITLE "Welcome to Tile Pile"
  !define MUI_WELCOMEPAGE_TEXT "Click Next to install this game"

  !define MUI_STARTMENUPAGE_REGISTRY_ROOT "HKCU"
  !define MUI_STARTMENUPAGE_REGISTRY_KEY "Software\TilePile"
  !define MUI_STARTMENUPAGE_REGISTRY_VALUENAME "TilePile"

  !define MUI_FINISHPAGE_TITLE "Installation complete"
  !define MUI_FINISHPAGE_SHOWREADME "$INSTDIR\manual.pdf"
  !define MUI_FINISHPAGE_SHOWREADME_TEXT "View manual (pdf)"

  !define MUI_FINISHPAGE_RUN_TEXT "Play the game now"
  !define MUI_FINISHPAGE_RUN $PROGRAM_LOCATION
  !define MUI_FINISHPAGE_RUN_NOTCHECKED
  !define MUI_FINISHPAGE_LINK "Visit the Tile Pile website"
  !define MUI_FINISHPAGE_LINK_LOCATION "http://tilepile.org"

  !define MUI_UNCONFIRMPAGE_TEXT_TOP "Note: The $\"Progress$\" file and any levelsets you have created in the below folder will not be deleted."

;--------------------------------
;Pages

  !insertmacro MUI_PAGE_WELCOME
  !insertmacro MUI_PAGE_LICENSE "LICENSE.txt"
  !insertmacro MUI_PAGE_DIRECTORY
  !insertmacro MUI_PAGE_STARTMENU Application $STARTMENU_FOLDER
  !insertmacro MUI_PAGE_INSTFILES
  !insertmacro MUI_PAGE_FINISH

  !insertmacro MUI_UNPAGE_CONFIRM
  !insertmacro MUI_UNPAGE_INSTFILES
  
;--------------------------------
;Languages
 
  !insertmacro MUI_LANGUAGE "English"

;--------------------------------
;Installer Sections

Section "Dummy Section" SecDummy

  SetOutPath "$INSTDIR"
  
  ;ADD YOUR OWN FILES HERE...
  File "TilePile.exe"
  File "TilePile_D3D.exe"
  File "TilePile.jar"
  File "manual.txt"
  File "manual.pdf"
  File "LICENSE.txt"
  
  ;Store installation folder
  WriteRegStr HKCU "Software\TilePile" "" $INSTDIR
  
  ;Create uninstaller and corresponding registry entries
  WriteUninstaller "$INSTDIR\Uninstall.exe"

  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\TilePile" "DisplayName" "Tile Pile"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\TilePile" "UninstallString" "$INSTDIR\Uninstall.exe"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\TilePile" "InstallLocation" "$INSTDIR"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\TilePile" "DisplayIcon" "$INSTDIR\JTP.exe"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\TilePile" "DisplayVersion" "${VERSION}"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\TilePile" "URLInfoAbout" "http://tilepile.org"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\TilePile" "HelpLink" "file://$INSTDIR\manual.pdf"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\TilePile" "Contact" "support@tilepile.org"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\TilePile" "Publisher" "The Tile Pile People"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\TilePile" "Comments" "Tile Pile is a puzzle game with an arcade twist."
  

  ;Store program location so it can be run when installation finished
  StrCpy $PROGRAM_LOCATIOn "$INSTDIR\TilePile.exe"

  !insertmacro MUI_STARTMENU_WRITE_BEGIN Application
    
    ;Create shortcuts
    CreateDirectory "$SMPROGRAMS\$STARTMENU_FOLDER"
    CreateDirectory "$SMPROGRAMS\$STARTMENU_FOLDER\More"
    CreateShortCut "$SMPROGRAMS\$STARTMENU_FOLDER\Tile Pile.lnk" "$INSTDIR\TilePile.exe" "" "" "" "" "" "Play the game"
    CreateShortCut "$SMPROGRAMS\$STARTMENU_FOLDER\Manual.lnk" "$INSTDIR\manual.pdf" "" "" "" "" "" "Read the manual (PDF)"
    CreateShortCut "$SMPROGRAMS\$STARTMENU_FOLDER\Manual (Text Only).lnk" "$INSTDIR\manual.txt" "" "" "" "" "" "Read the manual (TXT)"
    CreateShortCut "$SMPROGRAMS\$STARTMENU_FOLDER\Uninstall.lnk" "$INSTDIR\Uninstall.exe" "" "" "" "" "" "Remove the game from your computer"
    CreateShortCut "$SMPROGRAMS\$STARTMENU_FOLDER\More\Tile Pile - Low.lnk" "$INSTDIR\TilePile.exe" "--fast" "" "" "" "" "Run the game without antialiasing"
    CreateShortCut "$SMPROGRAMS\$STARTMENU_FOLDER\More\Tile Pile - D3D.lnk" "$INSTDIR\TilePile_D3D.exe" ""  "" "" "" "" "Try to force Direct3D acceleration"
  
  !insertmacro MUI_STARTMENU_WRITE_END


SectionEnd

;--------------------------------
;Descriptions

  ;Language strings
  LangString DESC_SecDummy ${LANG_ENGLISH} "A test section."

  ;Assign language strings to sections
  !insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
    !insertmacro MUI_DESCRIPTION_TEXT ${SecDummy} $(DESC_SecDummy)
  !insertmacro MUI_FUNCTION_DESCRIPTION_END
 
;--------------------------------
;Uninstaller Section

Section "Uninstall"

  ;ADD YOUR OWN FILES HERE...

  Delete "$INSTDIR\TilePile.exe"
  Delete "$INSTDIR\TilePile_D3D.exe"
  Delete "$INSTDIR\TilePile.jar"
  Delete "$INSTDIR\manual.txt"
  Delete "$INSTDIR\manual.pdf"
  Delete "$INSTDIR\LICENSE.txt"
  Delete "$INSTDIR\Uninstall.exe"

  RMDir "$INSTDIR"

  !insertmacro MUI_STARTMENU_GETFOLDER Application $MUI_TEMP
    
  Delete "$SMPROGRAMS\$MUI_TEMP\Tile Pile.lnk"
  Delete "$SMPROGRAMS\$MUI_TEMP\Manual.lnk"
  Delete "$SMPROGRAMS\$MUI_TEMP\Manual (Text Only).lnk"
  Delete "$SMPROGRAMS\$MUI_TEMP\Uninstall.lnk"
  Delete "$SMPROGRAMS\$MUI_TEMP\More\Tile Pile - Low.lnk"
  Delete "$SMPROGRAMS\$MUI_TEMP\More\Tile Pile - D3D.lnk"
  RMDir "$SMPROGRAMS\$MUI_TEMP\More"

  ;Delete empty start menu parent diretories
  StrCpy $MUI_TEMP "$SMPROGRAMS\$MUI_TEMP"
 
  startMenuDeleteLoop:
	ClearErrors
    RMDir $MUI_TEMP
    GetFullPathName $MUI_TEMP "$MUI_TEMP\.."
    
    IfErrors startMenuDeleteLoopDone
  
    StrCmp $MUI_TEMP $SMPROGRAMS startMenuDeleteLoopDone startMenuDeleteLoop
  startMenuDeleteLoopDone:

  DeleteRegKey HKCU "Software\TilePile"
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\TilePile"

SectionEnd