/* ========================================================================= *
 * JTilePile (C) 2008 by V.Termanis                                          *
 * TilePile game concept (C) 2008 by J.Mitchell                              *
 * ========================================================================= */
package JTP;

/**
 * Gravity tile
 * @author V.Termanis
 */
public class GrvTile extends Tile {

  
  /**
   * Constructs a new <code>GrvTile</code> instance with the given attributes.
   * @param height of the pile
   * @throws TileException if the height is not valid.
   */
  public GrvTile(int height) throws TileException {
    this.height = height;
    tileCheck();
    type = GRAVITY;
  }
  

  /**
   * Used to compare two tiles, ignoring their respective heights.
   * @param t the <code>Tile</code> instance to compare the current tile with.
   * @return <code>true</code> if the two <code>Tile</code> instances
   * are equal disregarding their heights.
   */
  public boolean equalsApartFromHeight(Tile t) {
    return t.getType() == GRAVITY;
  }


  /**
   * Creates an exact (non-shallow) copy of the current tile
   * @return a copy of the <code>Tile</code> instance.
   */
  public Tile copy() {
    try {
      return new GrvTile(height);
      // this should never happen
    }	catch (Exception e) {
      e.printStackTrace();
    }
    return null;
  }

}