/* ========================================================================= *
 * JTilePile (C) 2008 by V.Termanis                                          *
 * TilePile game concept (C) 2008 by J.Mitchell                              *
 * ========================================================================= */
package JTP;

/**
 * Normal tile (startable)
 * @author V.Termanis
 */
public class NrmTile extends StartableTile {


  /**
   * Constructs a new <code>GrvTile</code> instance with the given attributes.
   * @param height of the pile
   * @param levelStart indicates whether this is a start
   * @throws TileException if <code>height</code> is invalid.
   */
  public NrmTile(int height, boolean levelStart) throws TileException {
    this.height = height;
    tileCheck();
    setStart(levelStart);
    type = NORMAL;
  }


  /**
   * Used to compare two tiles, ignoring their respective heights.
   * @param t the <code>Tile</code> instance to compare the current tile with.
   * @return <code>true</code> if the two <code>Tile</code> instances
   * are equal disregarding their heights.
   */
  public boolean equalsApartFromHeight(Tile t) {
    if (t.getType() == NORMAL) {
      return levelStart == ((NrmTile) t).isStart();
    } else {
      return false;
    }
  }


  /**
   * Creates an exact (non-shallow) copy of the current tile
   * @return a copy of the <code>Tile</code> instance.
   */
  public Tile copy() {
    try {
      return new NrmTile(height, levelStart);
      // this should never happen
    }	catch (Exception e) {
      e.printStackTrace();
    }
    return null;
  }

}