/* ========================================================================= *
 * JTilePile (C) 2008 by V.Termanis                                          *
 * TilePile game concept (C) 2008 by J.Mitchell                              *
 * ========================================================================= */
package JTP;

import java.awt.*;

/**
 * This is a subclass of <code>Rectangle</code>.
 * Main use of this class is for button images (most of which are square
 * in this interface implementation)
 * @author V.Termanis
 */
public class Square extends Rectangle {

  /**
   * Constructs a new Rectangle whose upper-left corner is specified as (x,y)
   * and whose width and height are equal
   * @param x the specified X coordinate
   * @param y the specified Y coordinate
   * @param size the width and height of the <code>Square</code>
   */
  public Square(int x, int y, int size) {
    this.x = x;
    this.y = y;
    this.width = size;
    this.height = size;
  }

  
  /**
   * Sets the size of this Rectangle to the specified width and height.
   * @param size the new width and height for this <code>Square</code>
   */
  public void setSize(int size) {
    this.width = size;
    this.height = size;
  }

}